// -*- C++ -*-
// Copyright (C) 2000 Red Hat, Inc.
// Example/test code using Inti::Gtk::Object
/*
  The following license applies to this example code, but not to
  the Inti library itself:
  
    Permission is hereby granted, free of charge, to any person obtaining
    a copy of this software and associated documentation files (the
    "Software"), to deal in the Software without restriction, including
    without limitation the rights to use, copy, modify, merge, publish,
    distribute, sublicense, and/or sell copies of the Software, and to
    permit persons to whom the Software is furnished to do so, subject to
    the following conditions:

    The above copyright notice and this permission notice shall be
    included in all copies or substantial portions of the Software.

    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
    EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
    MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
    NONINFRINGEMENT.  IN NO EVENT SHALL THE COPYRIGHT HOLDER OR
    DISTRIBUTOR OF THE SOFTWARE BE LIABLE FOR ANY CLAIM, DAMAGES OR
    OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
    OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE
    OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/

#include <inti/gtk/object.h>
#include <inti/gtk/gtkbase.h>
#include <vector>
#include <string>
#include <iostream>

using namespace Inti;

class MyObject : public Gtk::Object
{
public:

protected:
  virtual void destroy_impl ()
  {
    cout << "destroyed!" << endl;
    // destroy implementations must always chain up!
    Object::destroy_impl ();
  }
  
};

int
main (int argc, char **argv)
{
  MyObject * obj;

  Gtk::init (&argc, &argv);
  
  obj = new MyObject;

  obj->destroy ();
  
  return 0;
}

